fn main() {
    let result: i32 = (0..1000)
        .into_iter()
        .filter(|x| x % 3 == 0 || x % 5 == 0)
        .sum();

    println!("Result: {}", result);
}

#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
        let result: i32 = (0..10)
            .into_iter()
            .filter(|x| x % 3 == 0 || x % 5 == 0)
            .sum();
        assert_eq!(result, 23);
    }
}
